#ifndef _GQIE_H_
#define _GQIE_H_

#include "trie.h"
#include <mpfr.h>	
#include "partitionnode.h"

typedef unsigned int uint;


class GQIE
{
public:
	static void setpn(PartitionBlock* pbs) { partitionblocks = pbs; };
	
	static void gqie(Node<uint> *node)
	{
		if (node->children.size == 0)
			return;
		for (int i=0; i<node->children.size; ++i)
			gqie(node->children.map[i].second);
		trie_subtract(node, node->children.map[0].second);
		return;
	}

	static void trie_subtract(Node<uint> *node1, Node<uint> *node2)
	{
		mpfr_sub(partitionblocks[node2->val].node->size, partitionblocks[node2->val].node->size, partitionblocks[node1->val].node->size, GMP_RNDN);
		if (node1->children.size == 0 || node2->children.size == 0)
			return;
		
		int i = 0, j = 0;
		while (i < node1->children.size && j < node2->children.size) {
			if (node1->children.map[i].second==node2->children.map[j].second) {
				trie_subtract(node1->children.map[i].second, node2->children.map[j].second);
				++i;
				++j;
			}
			else if (node1->children.map[i].second < node2->children.map[j].second) {
				++i;
			}
			else {
				++j;
			}
		}
		
		return;
	}
	
public:
	static PartitionBlock *partitionblocks;
	
};

#endif // _GQIE_H_
