#ifndef _PARTITIONNODE_H_
#define _PARTITIONNODE_H_

#include <mpfr.h>
#include <string.h>
#include "bitvector.h"



class PartitionNode
{
public:
	PartitionNode();
	~PartitionNode();
	
	PartitionNode & operator=(const PartitionNode & other);
	
	void copy_fixed(const PartitionNode & other) {
		fixed = other.fixed;
	}
	void set_fixed_bit(unsigned int bit) {
		fixed.set_bit(bit);
	}
	void count_fixed() {
		fixed.count_bits();
	}
	bool isfixed(unsigned int bit) {
		return fixed.isset(bit);
	}
	
	static void set_n(int n);
	static void set_mode(bool use_items = false, bool use_rowmargins=false);
	static void set_d(int d);
	
public:
	mpfr_t size;
	mpfr_t prob;
	mpfr_t cum_size;
	
	mpfr_t *cum_size_array;
	mpfr_t *size_array;
	
	BitVector fixed;
	
	static int n;
	static int d;
	
	static int size_prec;
	static int prob_prec;
	static bool use_items;
	static bool use_rowmargins;
	
	//static const int word = 8 * sizeof(unsigned int);
	
};


class PartitionBlock
{
public:
	PartitionBlock () : index(0), node(0) { } ;
	~PartitionBlock() { delete node; node = 0; } ;
	
	unsigned int index;
	PartitionNode *node;
};

#endif //_PARTITIONNODE_H_
